t / test-lib.shon commit Merge branch 'jc/utf8' (eff7375)
   1#!/bin/sh
   2#
   3# Copyright (c) 2005 Junio C Hamano
   4#
   5
   6# For repeatability, reset the environment to known value.
   7LANG=C
   8LC_ALL=C
   9PAGER=cat
  10TZ=UTC
  11export LANG LC_ALL PAGER TZ
  12EDITOR=:
  13VISUAL=:
  14unset AUTHOR_DATE
  15unset AUTHOR_EMAIL
  16unset AUTHOR_NAME
  17unset COMMIT_AUTHOR_EMAIL
  18unset COMMIT_AUTHOR_NAME
  19unset GIT_ALTERNATE_OBJECT_DIRECTORIES
  20unset GIT_AUTHOR_DATE
  21GIT_AUTHOR_EMAIL=author@example.com
  22GIT_AUTHOR_NAME='A U Thor'
  23unset GIT_COMMITTER_DATE
  24GIT_COMMITTER_EMAIL=committer@example.com
  25GIT_COMMITTER_NAME='C O Mitter'
  26unset GIT_DIFF_OPTS
  27unset GIT_DIR
  28unset GIT_EXTERNAL_DIFF
  29unset GIT_INDEX_FILE
  30unset GIT_OBJECT_DIRECTORY
  31unset SHA1_FILE_DIRECTORIES
  32unset SHA1_FILE_DIRECTORY
  33export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
  34export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
  35export EDITOR VISUAL
  36
  37case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
  38        1|2|true)
  39                echo "* warning: Some tests will not work if GIT_TRACE" \
  40                        "is set as to trace on STDERR ! *"
  41                echo "* warning: Please set GIT_TRACE to something" \
  42                        "other than 1, 2 or true ! *"
  43                ;;
  44esac
  45
  46# Each test should start with something like this, after copyright notices:
  47#
  48# test_description='Description of this test...
  49# This test checks if command xyzzy does the right thing...
  50# '
  51# . ./test-lib.sh
  52
  53error () {
  54        echo "* error: $*"
  55        trap - exit
  56        exit 1
  57}
  58
  59say () {
  60        echo "* $*"
  61}
  62
  63test "${test_description}" != "" ||
  64error "Test script did not set test_description."
  65
  66while test "$#" -ne 0
  67do
  68        case "$1" in
  69        -d|--d|--de|--deb|--debu|--debug)
  70                debug=t; shift ;;
  71        -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
  72                immediate=t; shift ;;
  73        -h|--h|--he|--hel|--help)
  74                echo "$test_description"
  75                exit 0 ;;
  76        -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
  77                verbose=t; shift ;;
  78        --no-python)
  79                # noop now...
  80                shift ;;
  81        *)
  82                break ;;
  83        esac
  84done
  85
  86exec 5>&1
  87if test "$verbose" = "t"
  88then
  89        exec 4>&2 3>&1
  90else
  91        exec 4>/dev/null 3>/dev/null
  92fi
  93
  94test_failure=0
  95test_count=0
  96
  97trap 'echo >&5 "FATAL: Unexpected exit with code $?"; exit 1' exit
  98
  99
 100# You are not expected to call test_ok_ and test_failure_ directly, use
 101# the text_expect_* functions instead.
 102
 103test_ok_ () {
 104        test_count=$(expr "$test_count" + 1)
 105        say "  ok $test_count: $@"
 106}
 107
 108test_failure_ () {
 109        test_count=$(expr "$test_count" + 1)
 110        test_failure=$(expr "$test_failure" + 1);
 111        say "FAIL $test_count: $1"
 112        shift
 113        echo "$@" | sed -e 's/^/        /'
 114        test "$immediate" = "" || { trap - exit; exit 1; }
 115}
 116
 117
 118test_debug () {
 119        test "$debug" = "" || eval "$1"
 120}
 121
 122test_run_ () {
 123        eval >&3 2>&4 "$1"
 124        eval_ret="$?"
 125        return 0
 126}
 127
 128test_skip () {
 129        this_test=$(expr "./$0" : '.*/\(t[0-9]*\)-[^/]*$')
 130        this_test="$this_test.$(expr "$test_count" + 1)"
 131        to_skip=
 132        for skp in $GIT_SKIP_TESTS
 133        do
 134                case "$this_test" in
 135                $skp)
 136                        to_skip=t
 137                esac
 138        done
 139        case "$to_skip" in
 140        t)
 141                say >&3 "skipping test: $@"
 142                test_count=$(expr "$test_count" + 1)
 143                say "skip $test_count: $1"
 144                : true
 145                ;;
 146        *)
 147                false
 148                ;;
 149        esac
 150}
 151
 152test_expect_failure () {
 153        test "$#" = 2 ||
 154        error "bug in the test script: not 2 parameters to test-expect-failure"
 155        if ! test_skip "$@"
 156        then
 157                say >&3 "expecting failure: $2"
 158                test_run_ "$2"
 159                if [ "$?" = 0 -a "$eval_ret" != 0 -a "$eval_ret" -lt 129 ]
 160                then
 161                        test_ok_ "$1"
 162                else
 163                        test_failure_ "$@"
 164                fi
 165        fi
 166        echo >&3 ""
 167}
 168
 169test_expect_success () {
 170        test "$#" = 2 ||
 171        error "bug in the test script: not 2 parameters to test-expect-success"
 172        if ! test_skip "$@"
 173        then
 174                say >&3 "expecting success: $2"
 175                test_run_ "$2"
 176                if [ "$?" = 0 -a "$eval_ret" = 0 ]
 177                then
 178                        test_ok_ "$1"
 179                else
 180                        test_failure_ "$@"
 181                fi
 182        fi
 183        echo >&3 ""
 184}
 185
 186test_expect_code () {
 187        test "$#" = 3 ||
 188        error "bug in the test script: not 3 parameters to test-expect-code"
 189        if ! test_skip "$@"
 190        then
 191                say >&3 "expecting exit code $1: $3"
 192                test_run_ "$3"
 193                if [ "$?" = 0 -a "$eval_ret" = "$1" ]
 194                then
 195                        test_ok_ "$2"
 196                else
 197                        test_failure_ "$@"
 198                fi
 199        fi
 200        echo >&3 ""
 201}
 202
 203# Most tests can use the created repository, but some amy need to create more.
 204# Usage: test_create_repo <directory>
 205test_create_repo () {
 206        test "$#" = 1 ||
 207        error "bug in the test script: not 1 parameter to test-create-repo"
 208        owd=`pwd`
 209        repo="$1"
 210        mkdir "$repo"
 211        cd "$repo" || error "Cannot setup test environment"
 212        "$GIT_EXEC_PATH/git" init-db --template=$GIT_EXEC_PATH/templates/blt/ >/dev/null 2>&1 ||
 213        error "cannot run git init-db -- have you built things yet?"
 214        mv .git/hooks .git/hooks-disabled
 215        cd "$owd"
 216}
 217        
 218test_done () {
 219        trap - exit
 220        case "$test_failure" in
 221        0)
 222                # We could:
 223                # cd .. && rm -fr trash
 224                # but that means we forbid any tests that use their own
 225                # subdirectory from calling test_done without coming back
 226                # to where they started from.
 227                # The Makefile provided will clean this test area so
 228                # we will leave things as they are.
 229
 230                say "passed all $test_count test(s)"
 231                exit 0 ;;
 232
 233        *)
 234                say "failed $test_failure among $test_count test(s)"
 235                exit 1 ;;
 236
 237        esac
 238}
 239
 240# Test the binaries we have just built.  The tests are kept in
 241# t/ subdirectory and are run in trash subdirectory.
 242PATH=$(pwd)/..:$PATH
 243GIT_EXEC_PATH=$(pwd)/..
 244GIT_TEMPLATE_DIR=$(pwd)/../templates/blt
 245HOME=$(pwd)/trash
 246export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR HOME
 247
 248GITPERLLIB=$(pwd)/../perl/blib/lib:$(pwd)/../perl/blib/arch/auto/Git
 249export GITPERLLIB
 250test -d ../templates/blt || {
 251        error "You haven't built things yet, have you?"
 252}
 253
 254# Test repository
 255test=trash
 256rm -fr "$test"
 257test_create_repo $test
 258cd "$test"
 259
 260this_test=$(expr "./$0" : '.*/\(t[0-9]*\)-[^/]*$')
 261for skp in $GIT_SKIP_TESTS
 262do
 263        to_skip=
 264        for skp in $GIT_SKIP_TESTS
 265        do
 266                case "$this_test" in
 267                $skp)
 268                        to_skip=t
 269                esac
 270        done
 271        case "$to_skip" in
 272        t)
 273                say >&3 "skipping test $this_test altogether"
 274                say "skip all tests in $this_test"
 275                test_done
 276        esac
 277done